%$HeadURL: file:///srv/svn/sintro/pkg/sprof/man/nodesrunlength.Rd $
%$Id: nodesrunlength.Rd 245 2013-10-14 20:15:24Z gsawitzki $
%$Date: 2013-10-14 22:15:24 +0200 (Mon, 14 Oct 2013) $
%$Author: gsawitzki $
%$Revision: 245 $
\encoding{utf8}
\name{nodesrunlength}
\alias{nodesrunlength}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{Marginal information for run length from profile}
\description{
Run length count, by node and run length, from profile.}
\usage{
nodesrunlength(sprof, clean=TRUE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{sprof}{a \code{sprof} data structure with profiling information.}
  \item{clean}{boolean.}
}
\details{
If \code{clean=TRUE}, zero results are removed and the nodes are sorted by average time.

If \code{clean=TRUE}, zero results and sorting are preserved. Trailing nodes with zero count  
may have been lost in the process, and are added.

}
\value{A matrix \code{count[node, run length]} with a column giving the number of runs by run length and three additional columns
 \item{nr_runs}{sum of counts over all run lengths.}
 \item{total_time }{sum of \code{count*run length}}
 \item{avg_time }{\code{total_time / count}}
 }
%\references{
%%% ~put references to the literature/web site here ~
%}
\author{Günther Sawitzki <gsawitzki@users.r-forge.r-project.org>}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\examples{
		data(sprof01lm)
 		nodesrunlength(sprof01lm) 
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{manip}
